# -------------------------------------------------------------------- #
#   CGIparamJP.pm - CGI.pm wrapper for using Japanese characters
#   Copyright (C) 1998-2005 Kawasaki Yuusuke <u-suke@kawa.net>
# -------------------------------------------------------------------- #
#   1999/06/29 v1.77 CHECKBOX бThanks to Yamato!
#   1999/07/06 v1.79 KMimeMP.pm ˥ե륢åץʬʬΥ
#   1999/07/26 v1.81 KMimeMP.pm  use ʤƤɤ
#   2000/05/12 v1.91 Х: &decode_url_array()
#   2000/12/18 v2.00 ʸưȽ̡jcode.pl Jcode.pm б
#   2003/02/19 v2.01 ʸб&get_query_through() ɲ
#   2003/06/05 v2.02 ¸ʸ򢮤Ѵ(EUC)
#   2003/06/05 v2.03 PC ¸ʸ Mozilla б
#   2003/06/30 v2.04 emoji=amp бɥɸ೨ʸ&#65432;Ѵ
#   2004/03/10       ɥĥʸ &#xHHHH; Ѵ
#   2004/10/02       Vodafone ʸ &#xF000; ˰ưEZweb ʸ
#   2004/10/20 v2.10 Windows ĥ Shift_JIS (IBMĥ)б
#   2004/10/20 v2.11 emoji=escape ץ
#   2004/10/20 v2.12 Encode.pm б84=20ټưȽб
#   2004/10/20 v2.13  UTF-8 ϥ֥饦¦Υפǥ
#   2004/10/20 v2.14 Unicode::Map б졦ڹϤб
#   2004/10/21 v2.15 Encode561 б
#   2004/10/21 v2.16 EscapeSJIS б
#   2004/10/24 v2.17 EntityRef б
#   2004/10/26 v2.18 EscapeUTF8 б
# -------------------------------------------------------------------- #
#   2004/11/08 v3.00 CGIparamJP.pm ѹС3
#   2005/02/23 v3.01 ե륢åץɤб
# -------------------------------------------------------------------- #
    use strict;
    package CGIparamJP;
    use vars qw( $VERSION $DEBUG @ISA );
    @ISA = qw( CGI );
    $VERSION = "3.01";
#   $DEBUG = \*STDOUT;
#   $DEBUG = \*STDERR;
# -------------------------------------------------------------------- #
=head1 NAME

CGIparamJP.pm - CGI.pm wrapper for using Japanese characters

=head1 SYNOPSIS

    use strict;
    use CGI;                        # ɬ use CGI Ƥ
    use CGIparamJP;                 #  use CGIparamJP 

    my $workcode = "UTF8";          # 
    my $defcode = "Shift_JIS";      # ϥɤΥǥե(ưȽ̼Ի)

    my $cgi = new CGIparamJP();
    my $entcode = $cgi->set_param_charset( $workcode, $defcode );
    my $query = $cgi->Vars();       # ɤ߹

    print "Content-Type: text/html\n\n";
    foreach my $key ( sort keys %$query ) {
        my $val = $query->{$key};
        print "$key : $val\n";
    }

=head1 DESCRIPTION

CGIparamJP.pm  CGI.pm Ѿơset_param_charset ᥽åɤɲäޤ
set_param_charset ᥽åɰʳ̤̾ CGI.pm ѤǤޤ

=head2 use CGIparamJP

use CGIפɬuse CGIparamJPפ֤Ƥ

CGI.pm ʤĶξϡCGIparamJP.pm ȼ롼ˤ
paramVars ᥽åɤ󶡤뤿ᡢuse CGIפפǤ
ξ CGI.pm 󶡤ե륢åץ
ȤߤѤǤޤ

=head2 set_param_charset()

set_param_charset ᥽åɤǤϲʸɼưȽ롼˴Ťơ
ѿʸɤưȽ̤ƤΥѿʸɤ
Ѵޤparam ᥽åɤ Vars ᥽åɤƤӽФ
set_param_charset ᥽åɤƤӽФƤ

ǥեȻꤷʸɤ¾ˡ
եʸȽѤΥߡѿळȤ
ۤܳμ¤ʸȽԤޤ

    <INPUT TYPE="hidden" NAME="84" VALUE="20">

ʸɤȤˡء٤ȡءޡ٤ʸֹ椬ۤʤ뤳ȤѤƤޤ
Ƚ̤ǽʸɤϰʲ̤Ǥ

    ܸ JIS
    ܸ Shift_JIS    (CP932)
    ܸ EUC-JP
    ڹ EUC-KR       (CP949)
    λ GB2312 (CP936)
    λ BIG5   (CP950)
    UTF8
    Latin1

ޤϡѿ ie Ѥơʸɤꤹ뤳ȤǽǤ

    <INPUT TYPE="hidden" NAME="ie" VALUE="Shift_JIS">

֥饦˼ưѴʤĶǤΤߤѤ

=head1 TODO

ե륢åץɤбƤ뤫ưǧ

=head1 AUTHORS

Copyright 1998-2004 Kawasaki Yusuke u-suke@kawa.net

=cut
# -------------------------------------------------------------------- #
    use Encode561;      # ʸѴ
    use EscapeSJIS;     # Shift_JIS ʸIBM ĥѴ
    use EscapeUTF8;     # ץUTF8ξ
# -------------------------------------------------------------------- #
#  use CGIparamJP;٤ƤӽФˡuse CGI;٤򤷤ƤʤС
#   δؿǾ񤭤롣ʸƤӽФա
# -------------------------------------------------------------------- #
sub import {
    if ( defined $CGI::VERSION ) {
        *new = undef;
        *param = undef;
        *delete_all = undef;
        *Vars = undef;
        *cookie = undef;
    } else {
        *new = \&CGIparamJP::orig::new;
        *param = \&CGIparamJP::orig::param;
        *delete_all = \&CGIparamJP::orig::delete_all;
        *Vars = \&CGIparamJP::orig::Vars;
        *cookie = \&CGIparamJP::orig::cookie;
    }
}
# -------------------------------------------------------------------- #
sub set_param_charset {
    $DEBUG and print $DEBUG "[set_param_charset=",join(" ",@_),"]\n";
    my $cgi = shift;
    my $workcode = shift;   # ɡɬܡ
    my $entdefault = shift; # ϥɡʼưȽ̼ԻΥǥե͡

    # äƤΥͤϥåɤ߹
    my $oldvar = {};
    foreach my $key ( $cgi->param() ) {
		my @val = $cgi->param( $key );
        $oldvar->{$key} = ( scalar @val > 1 ) ? \@val : $val[0];
    }

    # ʸɤѴ
    my( $newvar, $entcode ) = &convert_hash( $oldvar, $workcode, $entdefault );

    # ƤΥ򤤤ä
    $cgi->delete_all();

    # ƤΥƤϿľ
    foreach my $key ( keys %$newvar ) {
        my $val = $newvar->{$key};
        if ( ! ref $val ) {
            $cgi->param( "-name" => $key, "-value" => $val );
        } elsif ( ref $val ne "ARRAY" ) {
            $cgi->param( "-name" => $key, "-value" => $val );
        } elsif ( scalar @$val == 1 ) {
            $cgi->param( "-name" => $key, "-value" => $val->[0] );
        } else {
            $cgi->param( "-name" => $key, "-values" => $val );
        }
    }

    # ʸɤ֤
    $entcode;
}
# -------------------------------------------------------------------- #
sub convert_hash {
    $DEBUG and print $DEBUG "[convert_hash:",join(" ",@_),"]\n";
    my $oldvar = shift;
    my $workcode = shift;   # ɡɬܡ
    my $entdefault = shift; # ϥɡʼưȽ̼ԻΥǥե͡

    my $entcode;			# ϥɡʳ
    # ʸɤưȽꤹ
	$entcode ||= &charset_detect( $oldvar );
	# ѿ ie ǤǤ
	$entcode ||= $oldvar->{ie} if defined $oldvar->{ie};
	# ץ󥹤128255СǥեȤʸɤˤ
    $entcode ||= $entdefault if scalar grep {/[\e\x80-\xFF]/} %$oldvar;

    # ϥȽ˼Ԥĥǥե̤ä齪λ
    return (wantarray ? ( $oldvar, undef ) : $oldvar) unless $entcode;

    # ̤äѴ˽λ
    return (wantarray ? ( $oldvar, $entcode ) : $oldvar) unless $workcode;

    # ϥɤ Shift_JIS ʤ顢EscapeSJIS Ѥ
    my $entsjis;
    if ( $entcode =~ /^(CP932|Shift[\_\-]?JIS)$/i && 
         defined $EscapeSJIS::VERSION ) {
        $entsjis ++;
    }

    # EntityRef.pm Ѳǽʤ顢Ѥ
    my $entref;
    if ( defined $EntityRef::VERSION ) {
        $entref = new EntityRef();
    }

    # ɤ UTF-8 ξϡ&#xHHHH; ɽǥɤ
    my $escutf8;
    if ( $workcode =~ /^UTF-?8$/i && 
         defined $EscapeUTF8::VERSION ) {
        $escutf8 ++;
    }

    # ʸɤѴ롢ʸפ䡢λȤŸ
    my $newvar = {};
    foreach my $key ( keys %$oldvar ) {
        my $val = $oldvar->{$key};
        foreach my $str ( $key, (ref $val eq "ARRAY" ? @$val : $val) ) {
#           $DEBUG and print $DEBUG "[convert_hash:$key=$str]\n";
			next if ref $str;
            EscapeSJIS::escape( \$str ) if $entsjis;
            Encode561::from_to( \$str, $entcode, $workcode );
            $entref->entity2hex( \$str ) if $entref;
            EscapeUTF8::unescape( \$str ) if $escutf8;
        }
        $newvar->{$key} = $val;
    }

	# ե륢åץɤǤϡFh 饹Υե󥹤ˤʤΤǡ
	# ʸѴǤʤǤ⥹顼ǥե̾ɤ᤽

    return (wantarray ? ( $newvar, $entcode ) : $newvar);
}
# -------------------------------------------------------------------- #
#   γͤʸɤ򢭤Ƚѥߡѿ鼫ưȽ̤
#   <INPUT TYPE="hidden" NAME="84" VALUE="20">
#   ء٤ȡءޡ٤ϡ줴Ȥʸɤۤʤ뤳ȤѤƤ
# -------------------------------------------------------------------- #
#   ߤ utf8sjiseuc Τб Encode.pm бƤ
#   ASCII   Unicode ܸ  ܸ  GB2312  ڹ  BIG5
#   LATIN-1 UTF-8   CP932   EUC-JP  CP936   CP949   CP950  # NAME
#   00F7    C3B7    8180    A1E0    A1C2    A1C0    A1D2   # DIVISION SIGN   
#   00B1    C2B1    817D    A1DE    A1C0    A1BE    A1D3   # PLUS-MINUS SIGN 
# -------------------------------------------------------------------- #
sub charset_detect {
    $DEBUG and print $DEBUG "[charset_detect:",join(" ",@_),"]\n";
    my $hash = shift;
    my $getcode;

	# ƥɤȤ DIVISION SIGN  ʸʼưȽѡ
	my $DIVISION_SIGN = {
		"\e\$B\x21\x60\e\(B" => "iso-2022-jp",	# ܸ JIS
		"\x81\x80"	=>	"cp932",				# ܸ Shift_JIS
		"\xA1\xE0"	=>	"euc-jp",				# ܸ EUC-JP
		"\xA1\xC2"	=>	"cp936",				# λ GB2312
		"\xA1\xC0"	=>	"cp949",				# ڹ EUC-KR
		"\xA1\xD2"	=>	"cp950",				# λ BIG5
		"\xC3\xB7"	=>	"utf8", 				# UTF-8
		"\xF7"		=>	"iso-8859-1",			# Latin1
	};

	# ƥɤȤ PLUS-MINUS SIGN  ʸʼưȽѡ
	my $PLUSMINUS_SIGN = {
		"\e\$B\x21\x5E\e\(B" => "iso-2022-jp",	# ܸ JIS
		"\x81\x7D"	=>	"cp932",				# ܸ Shift_JIS
		"\xA1\xDE"	=>	"euc-jp",				# ܸ EUC-JP
		"\xA1\xC0"	=>	"cp936",				# λ GB2312
		"\xA1\xBE"	=>	"cp949",				# ڹ EUC-KR
		"\xA1\xD3"	=>	"cp950",				# λ BIG5
		"\xC2\xB1"	=>	"utf8", 				# UTF-8
		"\xB1"		=>	"iso-8859-1",			# Latin1
	};

    # ɽ | ¤٤
    my $DIVISION_RE  = join( "|", map {"\Q$_\E"} sort keys %$DIVISION_SIGN );
    my $PLUSMINUS_RE = join( "|", map {"\Q$_\E"} sort keys %$PLUSMINUS_SIGN );

    foreach my $key ( keys %$hash ) {

        # ѿ̾84פηˤʤäƤ뤫
        next unless ( $key =~ /^(\d+)($DIVISION_RE)(\d+)$/ );
        my( $div1, $strkey, $div2 ) = ( $1, $2, $3 );
        next unless $div1;              # ʬҤɬ
        next unless $div2;              # ʬɬ
        my $codekey = $DIVISION_SIGN->{$strkey} or next;
        $DEBUG and print $DEBUG "[key:$div1/$div2=$codekey]\n";

        # ѿͤ20פηˤʤäƤ뤫
		my $val = $hash->{$key};
		$val = $val->[0] if ref $val;
        next unless ( $val =~ /^(\d+)($PLUSMINUS_RE)(\d+)$/ );
        my( $pls1, $strval, $pls2 ) = ( $1, $2, $3 );
        next unless $pls1;              # ɬ
        next if $pls2;                  # ޤα¦ɬ0
        my $codeval = $PLUSMINUS_SIGN->{$strval} or next;
        $DEBUG and print $DEBUG "[value:$pls1+$pls2=$codeval]\n";

        # Фʸɤơķ׻г
        if ( $codekey eq $codeval && $div1 / $div2 == $pls1 ) {
            $DEBUG and print $DEBUG "[detect:$codekey]\n";
            return $codekey;            # ꤷ
        }
    }

    undef;                              # ФǤʤä
}
# ==================================================================== #
    package CGIparamJP::orig;
	use vars qw( $DEBUG );
# ==================================================================== #
sub new {
	$DEBUG = $CGIparamJP::DEBUG;
    $DEBUG and print $DEBUG "[new:",join(",",@_),"]\n";
    my $package = shift;
    my $obj = &input_query();
    bless $obj, $package;
    $obj;
}
# -------------------------------------------------------------------- #
sub delete_all {
    my $obj = shift;
    $DEBUG and print $DEBUG "[delete_all:",join(",",@_),"]\n";
    %$obj = ();
}
# -------------------------------------------------------------------- #
sub param {
    my $obj = shift;
    $DEBUG and print $DEBUG "[param:",join(",",@_),"]\n";

    if ( scalar @_ == 0 ) {         # ѥ᡼̾Υꥹ
        return keys %$obj;
    } elsif ( scalar @_ == 1 ) {    # ѥ᡼
        my $key = shift;
        my $val = $obj->{$key};
        if ( ! ref $val ) {
            return $val;            # Ȥȥ顼ͤʤ饹顼֤ͤ
        } elsif ( wantarray ) {
            return @$val;           # ֤ͤʤ顢֤ͤ
        } else {
            return join( "\0", @$val );     # \0 ڤ¤٤͡
        }
    } elsif ( scalar @_ == 2 ) {    # ѥ᡼ͤѹ
        my( $key, $val ) = @_;
        $obj->{$key} = $val;
    } elsif ( scalar @_ == 4 ) {    # ѥ᡼ͤѹ
        my $hash = { @_ };
        my $key = $hash->{"-name"};
        my $val = $hash->{"-values"} || $hash->{"-value"};
        $DEBUG and print $DEBUG "[param:$key=$val]\n";
        $obj->{$key} = $val;
    }
}
# -------------------------------------------------------------------- #
sub cookie {
    my $obj = shift;
    $DEBUG and print $DEBUG "[cookie:",join(",",@_),"]\n";

	undef;
}
# -------------------------------------------------------------------- #
sub Vars {
    my $obj = shift;
    $DEBUG and print $DEBUG "[Vars:",join(",",@_),"]\n";
    
    my $hash = {};
    foreach my $key ( $obj->param() ) {
        $hash->{$key} = $obj->param($key);
        $DEBUG and print $DEBUG "[Vars:$key=$hash->{$key}]\n";
    }

    $hash;
}
# -------------------------------------------------------------------- #
sub input_query {
    my $method   = $ENV{REQUEST_METHOD} if exists $ENV{REQUEST_METHOD};
    my $mimetype = $ENV{CONTENT_TYPE}   if exists $ENV{CONTENT_TYPE};
    my $length   = $ENV{CONTENT_LENGTH} if exists $ENV{CONTENT_LENGTH};

    my $enter;
    if( $method eq "POST" ){                    # ꡼ɤ߹
        if( $mimetype =~ m#multipart/form-data#i ){
            die "CGIparamJP.pm - $mimetype is not supported.\n";
        }else{
            read( *STDIN, $enter, $length );    # ̾ POST ξ
        }
    } elsif ( exists $ENV{QUERY_STRING} ) {
        $enter = $ENV{QUERY_STRING};
    }

    my $query = {};
    foreach my $elem ( split( /[&;]/, $enter )){
        my( $key, $val ) = split( /=/, $elem, 2 );
        $key =~ s/%([0-9A-Fa-f]{2})/pack(C=>hex($1))/ge;
        $key =~ tr/+/ /;
        $val =~ s/%([0-9A-Fa-f]{2})/pack(C=>hex($1))/ge;
        $val =~ tr/+/ /;
        $query->{$key} = [] unless ref $query->{$key};
        push( @{$query->{$key}}, $val );
    }

    $query;
}
# -------------------------------------------------------------------- #
;1; # End of the script.
# -------------------------------------------------------------------- #
