# -------------------------------------------------------------------- #
#   EmojiTrans.pm -- Emoji Translator
#   Copyright 2004-2005 Kawasaki Yuusuke <u-suke@kawa.net>
# -------------------------------------------------------------------- #
#   2004/09/22  KHandle.pm ʬΥ
#   2004/10/01  Vodafone ʸб
#   2004/10/18  Vodafone ʸɤ &#xF000;&#xF8FF; ѹ
#   2004/10/21  KEmoji.pm ʬΥ
#   2004/10/22  ɥɸ೨ʸȽɲ
#   2004/10/24  ɽ EmojiTransMap.txt ʬΥ
#   2004/11/07  POD 򾯤ޤ
#   2004/12/01  UP.Browser/6.0.x Ǥϥɥ⢪EZͥƥѴʤ
#   2005/02/02  Vodafone 3GӤб
# -------------------------------------------------------------------- #
    package EmojiTrans;             # ѥå̾ EmojiTrans
    use strict;
    use integer;
    use vars qw( $VERSION $DEBUG );
# ----------------------------------------------------------------
    $VERSION = "0.01";
# -------------------------------------------------------------------- #
=head1 NAME

EmojiTrans -- Emoji Translator

=head1 DESCRIPTION

    use EmojiTrans;
    EmojiTrans::translate( \$str, $ENV{HTTP_USER_AGENT} );

裱ǡѴоʸؤΥե󥹤ꤷޤ
ʸͽ &#xHHHH; ɽˤƤɬפޤ
EmojiTrans.pm ⥸塼ñΤǤϥХʥγʸϽǤޤΤǡ
ͽ EscapeSJIS.pm ⥸塼 escape ؿʤɤѤ
Хʥꥳɤ &#xHHHH; ɽѴƤɬפޤ
ʤɥ⳨ʸˤĤƤϡ&#ddddd;Shift_JIS10ɽˤѤǤޤ
ʸɤ EUC-JPShift_JISUTF-8 ѲǽǤʻס

裲ǡѴΥ֥饦̾ꤷޤ
ƥꥢȤ˲Τ褦ѴȤʤޤ

    ɥɸ೨ʸ   - ĥʸϻɸ೨ʸ˺ؤޤ
                             VodafoneʸEZwebʸѤǤޤ

    ɥĥʸ   - ƤΥɥ⳨ʸ(ɸܳĥ)ѤǤޤ
                             VodafoneʸEZwebʸѤǤޤ

    Vodafoneѥåȵ - VodafoneʸΥڡ13ѤǤޤ
                             ɥ⳨ʸϻVodafoneʸ˺ؤޤ

    Vodafoneѥåȵ   - ƤVodafoneʸ(ڡ16)ѤǤޤ
                             ɥ⳨ʸϻVodafoneʸ˺ؤޤ

    EZweb HDML         - ɥɸ೨ʸ &#ddddd; ǽϤޤ
                             ɥĥʸѤǤޤ

    EZweb XHTML        - Ƥ EZweb ʸѤǤޤ
                             ɥ⳨ʸϻVodafoneʸ˺ؤޤ

=head1 CONFIGURATION

    EmojiTransMap.txt

EmojiTransMap.txt ϡɥ¾ꥢγʸѴޥåפǤ
EmojiTrans.pm եƱǥ쥯ȥ֤Ƥ
ʸɤϣꥢȤ Unicode ǻꤵƤޤ
ʤ Vodafone ʸɤ F001F53A ˰ưƤޤ
ʸѴɲáѹϡEmojiTransMap.txt 򹹿Ƥ

=head1 MEMO

¾εŤȡ¿ʥ񤤤Ƥޤ

=head2 EZweb XHTMLγʸˤĤ

EZweb  UP.Browser/6.0.x  XHTML Ǥϡ
EZweb ʸ &#xHHHH; ɽ
Shift_JIS Хʥꥳɤϼդޤ
i⡼ɳʸ Shift_JIS Хʥꥳɤ
(餯EZweb GW󥿤Ѵ)ɽǤΤǡ
εǤϡɥ⳨ʸEZwebͥƥֳʸ
Ѵϼ»ܤʤǤ

ʹߤ UP.Browser/6.2.x  XHTML Ǥϡ
EZweb ʸ Shift_JIS Хʥꥳɤդޤ
(Ѥ餺 &#xHHHH; ɽϼդޤ)
μ¤ˤϡ<img localsrc="**"> ΥѤ
EZweb Τɤ XHTML ǤɽǤޤ
ɥ⡦ܡեȤθߴݤǤޤ͡

=head2 EZweb UP.BrowserСֹ

    UP.Browser/3.04   HDML
    UP.Browser/6.0.x  XHTML쵡
    UP.Browser/6.1.0  Google CHTML Proxy/1.0
    UP.Browser/6.2.0  XHTML

=head1 COPYRIGHT

    Copyright 2004-2005 Kawasaki Yusuke <u-suke@kawa.net>
    http://www.kawa.net/

=cut
# -------------------------------------------------------------------- #
    my $EMOJI_DOCOMO2VODAFONE;
    my $EMOJI_DOCOMO2EZWEB;
    my $EMOJI_DOCOMO2COLOR;
    my $EMOJI_DOCOMO_EXT2STD;
# -------------------------------------------------------------------- #
#   ꥢֳʸѴޥåפν
# -------------------------------------------------------------------- #
if ( ! ref $EMOJI_DOCOMO2EZWEB ) {
    my $pwd = &where_you_are();
    my $file = "$pwd/EmojiTransMap.txt";
    open( MAP, $file );
    while( <MAP> ) {
        next if /^\s*(#|$)/;
        chomp;
        my( $doext, $dostd, $ezweb, $voda, $color ) = split( /\t/, $_ );
        $EMOJI_DOCOMO2EZWEB->{$doext} = $ezweb if ( $ezweb =~ /^E/ );
        $EMOJI_DOCOMO2VODAFONE->{$doext} = $voda if ( $voda =~ /^[EF]/ );
        $EMOJI_DOCOMO2COLOR->{$doext} = $color if ( $color =~ /^[0-9A-F]/i );
        $EMOJI_DOCOMO_EXT2STD->{$doext} = $dostd if ( $dostd =~ /^[0-9A-F]/i );
    }
    close( MAP );
}
# -------------------------------------------------------------------- #
#   ɥɸ೨ʸʺοƳĥʸб
#   http://www.nttdocomo.co.jp/p_s/imode/make/spec/index.html
#   i⡼бHTML1.0501i
#   i⡼бHTML2.0502i
#   i⡼бHTML3.0503i
#   i⡼бHTML3.0FOMA 2001/2002/2101V 
# -------------------------------------------------------------------- #
my $DOCOMO_STD_EMOJI_HASH;
if ( ! ref $DOCOMO_STD_EMOJI_HASH ) {
    my $list = [qw(
        D501i   F501i   N501i   P501i   
        D502i   F502i   N502i   P502i   NM502i  SO502i  
        F502it  N502it  SO502iWM        SH821i  N821i   P821i   
        D209i   ER209i  F209i   KO209i  N209i   P209i   
        P209is  R209i   R691i   F210i   N210i   P210i   
        KO210i  F671i   
        D210i   SO210i  F503i   F503iS  P503i   P503iS  
        N503i   N503iS  SO503i  SO503iS D503i   D503iS  
        F211i   D211i   N211i   N211iS  P211i   P211iS  
        SO211i  R211i   SH251i  SH251iS R692i   N2001   
        N2002   D2101V  P2101V  SH2101V T2101V  
    )];
    foreach my $name ( @$list ) {
        $name =~ tr/A-Z/a-z/;
        $DOCOMO_STD_EMOJI_HASH->{$name} ++;
    }
}
# -------------------------------------------------------------------- #
#   HTTP_USER_AGENT ˤꡢɥɸ೨ʸʤ鿿֤
# -------------------------------------------------------------------- #
sub is_docomo_std_emoji {
    my $agent = shift or return;
    my $name = ( $agent =~ m#^DoCoMo/(?:1\.0/|2\.0\s+)([A-Za-z0-9]+)# )[0];
    $name =~ tr/A-Z/a-z/;
    $DOCOMO_STD_EMOJI_HASH->{$name};
}
# -------------------------------------------------------------------- #
#   ꥢ֤γʸѴ
# -------------------------------------------------------------------- #
sub translate {
    my $src = \$_[0];
    my $ref = ref $$src ? $$src : $src;     # ɬ٥Υե
    my $agent = $_[1] || $ENV{HTTP_USER_AGENT};

    # ߴΤᡢɥɽɽѴǼ»ܤ
    &tran_docomo_old2new( $ref );           # &#63647;&#xE63E;

    if ( $agent =~ m#^DoCoMo/# ) {          # ɥ
        # &tran_number2docomo( $ref );
        if ( &is_docomo_std_emoji( $agent ) ) {
            &tran_docomo_ext2std( $ref );   # ĥʸɸ೨ʸ
        }
    } elsif ( $agent =~ m#^UP.Brows# ) {    # EZweb HDML 
        # &tran_number2ezweb( $ref );
        &tran_docomo_ext2std( $ref );       # ĥʸɸ೨ʸ
        &tran_docomo_new2old( $ref );       # &#xE63E;&#63647;
    } elsif ( $agent =~ m#^KDDI-\w+\s+UP.Browser/(?!6\.0\.)# ) {
        # 6.0.x Ѵʤ C3002K/A1101S/INFOBAR ʤ
        # 6.2.x ʹߤѴ A5503SA/W21H ʤ
        # &tran_number2ezweb( $ref );
        &tran_docomo2ezweb( $ref );         # ɥ⢪EZwebʸ
    } elsif ( $agent =~ m#^(J-PHONE|Vodafone)/# ) {
        # &tran_number2vodafone( $ref );
        &tran_docomo2vodafone( $ref );      # ɥ⢪Vodafoneʸ
    } elsif ( $agent =~ m#^Moz# ) {
        # &tran_number2marusuji( $ref );
    }
}
# -------------------------------------------------------------------- #
#   ɥ⳨ʸ  au ʸѴ
# -------------------------------------------------------------------- #
sub tran_docomo2ezweb {
    my $ref = shift or return;
    $$ref =~ s/(\&\#x)(E[0-9A-F]{3})(;)
              /$1.($EMOJI_DOCOMO2EZWEB->{$2}||$2).$3/igex;
}
# -------------------------------------------------------------------- #
# ɥ⳨ʸ  Vodafone ʸѴ
# -------------------------------------------------------------------- #
sub tran_docomo2vodafone {
    my $ref = shift or return;
    $$ref =~ s/(\&\#x)(E[0-9A-F]{3})(;)
              /$1.($EMOJI_DOCOMO2VODAFONE->{$2}||$2).$3/igex;
}
# -------------------------------------------------------------------- #
#   ĥʸбξ硢ĥɸѴ
# -------------------------------------------------------------------- #
sub tran_docomo_ext2std {
    my $ref = shift or return;
    $$ref  =~ s/(\&\#x)([0-9A-F]{4})(;)
               /$1.($EMOJI_DOCOMO_EXT2STD->{$2}||$2).$3/igex;
}
# -------------------------------------------------------------------- #
#   i⡼ɳʸ &#63647;Unicode &#xE63E; ɽѴ
#   ɥε(Shift_JISɤ)򿷻ͤ˽
# -------------------------------------------------------------------- #
sub tran_docomo_old2new {
    my $ref = shift;
    $$ref =~ s/(\&\#(63[6-9][0-9][0-9]);)
              /&one_docomo_sjis2escape($2)||$1/gex;
}
# -------------------------------------------------------------------- #
#   i⡼ɳʸ Unicode &#xE63E;&#63647; ɽѴ
#   EZweb HDML ΣǣץѴϡ&#ddddd; ɽ
# -------------------------------------------------------------------- #
sub tran_docomo_new2old {
    my $ref = shift;
    $$ref =~ s/(\&\#x(E[0-9A-F]{3});)
              /&one_docomo_unicode2escape(hex($2))||$1/igex;
}
# -------------------------------------------------------------------- #
#   åɽ [0][9] ʸˤ
#       ͸ߤԻѡ{emoji.1} Ȥ &#xE6E2; ȤѤƲ
#   ɥ &#xE6E2;  &#xE6EB;190
#   EZweb  &#xE522;  &#xE5AC;190
#   Vodafone  &#xE21C;  &#xE225;190
#   Уä &#x2460;  &#x2468;19Τߡ
# -------------------------------------------------------------------- #
sub tran_number2docomo {
    my $ref = shift;
    $$ref =~ s/\[([0-9])\]/sprintf("&#x%04X;",0xE6E2+($1+9)%10)/gex;
}
sub tran_number2ezweb {
    my $ref = shift;
    $$ref =~ s/\[([0-9])\]/sprintf("&#x%04X;",0xE522+($1+9)%10)/gex;
}
sub tran_number2vodafone {
    my $ref = shift;
    $$ref =~ s/\[([0-9])\]/sprintf("&#x%04X;",0xE21C+($1+9)%10)/gex;
}
sub tran_number2marusuji {
    my $ref = shift;
    $$ref =~ s/\[([1-9])\]/sprintf("&#x%04X;",0x2460+$1-1)/gex;
}
# -------------------------------------------------------------------- #
#   ɥγʸ(Shift_JIS)Unicode &#xHHHH; Ѵ
# -------------------------------------------------------------------- #
sub one_docomo_sjis2escape {
    my $sjis = shift or return;
    my $code;

    if ( $sjis >= 63647 && $sjis <= 63996 ) {
        if ( $sjis <= 63740 ) {
            $code = $sjis-4705;
        } elsif ( $sjis <= 63870 ) {
            $code = $sjis-4772;
        } else {
            $code = $sjis-4773;
        }
    }
    my $str = sprintf( "&#x%04X;", $code ) if $code;
    $str;
}
# -------------------------------------------------------------------- #
#   ɥγʸ(Unicode)Shift_JIS &#ddddd; Ѵ
# -------------------------------------------------------------------- #
sub one_docomo_unicode2escape {
    my $code = shift or return;
    my $sjis;

    if ( $code >= 0xE63E && $code <= 0xE757 ) {
        if ( $code <= 0xE69B ) {
            $sjis = $code+4705;
        } elsif ( $code <= 0xE6DA ) {
            $sjis = $code+4772;
        } else {
            $sjis = $code+4773;
        }
    }
    my $str = sprintf( "&#%05d;", $sjis ) if $sjis;
    $str;
}
# -------------------------------------------------------------------- #
#   ¹Υե̾Ф
# -------------------------------------------------------------------- #
sub where_you_are {
    my $path = (caller(0))[1];      # ƤӽФ¹Υե̾
    $path =~ s#[^/]+$##s;           # ǥ쥯ȥ̾Ѵ
    $path = "." if ( $path eq "" );
    $path;                          # ǥ쥯ȥ֤̾
}
# -------------------------------------------------------------------- #
;1; # End of the script.
# -------------------------------------------------------------------- #
