# -------------------------------------------------------------------- #
#   Encode561.pm - Encode::from_to compatible for Perl 5.6.x and 5.005
#   Copyright (C) 1998-2005 Kawasaki Yuusuke <u-suke@kawa.net>
# -------------------------------------------------------------------- #
#   2004/10/21  ǽΥС
#   2004/10/25  EUC_JP  Latin1 ѴХ
#   2004/10/28  EUC_JP  ISO-2022-JP ѴХ
#   2004/11/07  POD 򾯤ޤ
#	2005/01/29  wide character Ƚ̽(Perl 5.8.x Ķ)
# -------------------------------------------------------------------- #
    package Encode561;
    use strict;
    use vars qw( $VERSION $DEBUG );
    $VERSION = "0.05";
# -------------------------------------------------------------------- #
=head1 NAME

Encode561.pm - Encode::from_to compatible for Perl 5.6.x and 5.005

=head1 SYNOPSIS

    use Encode561;
    my $text = "Hello, World!\n";
    Encode561::from_to( $text, "utf8", "cp932" );
    print $text;

=head1 DESCRIPTION

Encode.pm ܸǤʤ¿ѴͭѤǤ
Perl 5.8.x ʹߤǤѤǤޤ
бѾ塢ɤƤ Perl 5.005  Perl 5.6.x Ȥä
ŤСΤޤ޲ưƤޥ¿Ȼפޤ

Jcode.pm  Unicode::Map ǤȤ߹碌뤳Ȥ
Encode.pm Ʊν¸Ǥޤ
󥿡եۤʤ뤿ᡢץबʣˤʤäƤޤޤ

Encode561.pm ϡEncode::from_to ؿƱνԤؿ
Encode561::from_to ؿ󶡤ޤ

Perl 5.005  5.6.x Υо Encode561.pm Ѥ
ȯץPerl 5.8.x ΥФ Encode.pm 
ѤƲư뤳Ȥǽˤʤޤ

ޤPerl 5.8.x Ǥ Encode561.pm Ѥ뤳ȤǽǤ
Encode.pm ΤѤۤ®Ǥ礦顢
ץΡEncode561٤Encode٤Ƚ񤭴ۤ
פޤ

=head1 USAGE

from_to ؿΰν񼰤ϡEncode.pm ΤƱǤ

    [$length =] Encode561::from_to($octets, FROM_ENC, TO_ENC [, CHECK])

$octets ˤϡѴʸꤷޤ
FROM_ENC ˤϡѴθߤʸɤꤷޤ
TO_ENC ˤϡѴʸɤꤷޤ
裴(CHECK)ϡꤵƤƤ̵뤵ޤ
$length ϡѴΥХȿ֤ޤ

=head1 CHARSETS

Encode561.pm ǤϲʸɤѤǤޤ

¢롼ˤб륳ɡ

    UTF-8
    Latin1 (ISO-8859-1,ASCII)

Jcode.pm ˤб륳ɡ

    Shift_JIS   (CP932)
    EUC_JP      (x-euc-jp)
    JIS         (ISO-2022-JP)

Unicode::Map ˤбʥɡ

    EUC-KR (CP949)
    GB2312 (CP936)
    BIG5   (CP950)

¾Unicode::Map ݡȤ륳ɤϴŪѤǤޤ
Shift_JIS  CP932 ʸåۤʤޤؤΤᡢ
Ʊ뤷ƤޤJcode.pm ˤ sjis Ȥƽޤ

бʤɡ

    UCS2
    UTF-16

Encode561.pm Ǥϡ16bitɤˤбޤ
8bitɤޤ8bit߲ĹɤΤбƤޤ

=head1 PATCHS

Jcode.pm  Unicode::Map ǤϡUnicode ¾ΥɤѴ
ʸåȤɽǤʤʸϡ??פ֢פѴ줿ꡢ
Ƥޤޤ
Encode.pm ǤϤ򤹤 Encode::FB_XMLCREF ץ󤬤ޤ
Jcode.pm  Unicode::Map  FB_XMLCREF εǽ¸
ѥåץʢˤͽŬѤƤȤ򤪴ᤷޤ
http://www.kawa.net/works/jcode/uni-escape.html
ʸ &#xHHHH; η˥פ뤳Ȥǡʸɤޤ

=head1 TODO

Encode561.pm Ѥ뤳Ȥ Encode.pm ʤĶʡ5.6.1ʲˤǤ
Encode.pm ˶ᤤ¸Ǥޤȿ̡
Jcode.pm ޤ Unicode::Map ɬܤȤʤäƤޤޤ
󥿥륵ǥ⥸塼ɲå󥹥ȡǤ
jcode.pl ѤǤʤĶˤƤ
Shift_JISEUC-JPISO-2022-JP ֤Ѵ˸¤
ѤǤ褦˳ĥΤ⡢פ뤫⤷ޤ͡

=head1 COPYRIGHT

    Copyright 2004 Kawasaki Yusuke <u-suke@kawa.net>
    http://www.kawa.net/

=cut
# -------------------------------------------------------------------- #
#   Encode.pm  Jcode.pm Υ̾Ѵޥå
# -------------------------------------------------------------------- #
    my $ENC2JC = {
        "euc-jp"        =>  "euc",
        "euc_jp"        =>  "euc",
        "x-euc-jp"      =>  "euc",
        "x-sjis"        =>  "sjis",
        "shift_jis"     =>  "sjis",
        "shift-jis"     =>  "sjis",
        "cp932"         =>  "sjis",
        "iso-2022-jp"   =>  "jis",
        "utf8"          =>  "utf8",
        "utf-8"         =>  "utf8",
        "ascii"         =>  "ascii",
        "latin1"        =>  "ascii",
        "latin-1"       =>  "ascii",
        "iso-8859-1"    =>  "ascii",
    };
# -------------------------------------------------------------------- #
#   ֥ȤΥå
# -------------------------------------------------------------------- #
    my $CACHE_JCODE;
    my $CACHE_UNIMAP = {};
    my $CACHE_UNISTR;
# -------------------------------------------------------------------- #
#   Encode.pmߴѡˢ Encode561.pm ǤѤƤޤ
# -------------------------------------------------------------------- #
sub FB_DEFAULT  {    0; }
sub FB_CROAK    {    1; }
sub FB_QUIET    {    4; }
sub FB_WARN     {    6; }
sub FB_PERLQQ   {  256; }
sub FB_HTMLCREF {  512; }
sub FB_XMLCREF  { 1024; }
# -------------------------------------------------------------------- #
#   ѴѴʸɤꤹ
# -------------------------------------------------------------------- #
sub from_to {
    my $src = \$_[0];
    my $from = $_[1];
    my $to   = $_[2];
    my $opt  = $_[3];
    my $ref = ref $$src ? $$src : $src;     # ɬ٥Υե
    $DEBUG and print STDERR "[from_to: $from to $to]\n";
    $DEBUG and print STDERR "[before: ",length($$ref)," bytes]\n";

    if ( $from eq $to ) {
        # Ѵ夬Ʊɤξϲ⤷ʤ
    } elsif ( $$ref !~ /[^\x00-\x7F]/ ) {
        # ʸ 0127 ޤǤϰϤʤ鲿⤷ʤ
        # Perl 5.8.x Ǥϡ[^\x00-\x7F]  [\x80-\xFF] ΰ̣ۤʤ
        # Perl 5.8.x ǤϡԤ Latin-1 ϰϤΤߤ˸ꤵ
    } elsif ( $ENC2JC->{lc($from)} && $ENC2JC->{lc($to)} ) {
        # Jcode.pm ѲǽϰϤξϡEUC ͳѴ
        &euc_encode( $from, $ref, $opt );           # ǤբEUC
        &euc_decode( $to,   $ref, $opt );           # EUCǤ
    } else {
        # UCS2 ͳ᤽ñΤ UTF8 ͳѴ
        &encode( $from, $ref, $opt );               # ǤբUTF8
        &decode( $to,   $ref, $opt );               # UTF8Ǥ
    }

    $DEBUG and print STDERR "[after: ",length($$ref)," bytes]\n";
    return length( $$ref );
}
# -------------------------------------------------------------------- #
#   ¾Υɤ UTF8 Ѵ
# -------------------------------------------------------------------- #
sub encode {
    my $from = $_[0];
    my $src = \$_[1];
    my $opt = $_[2];
    my $ref = ref $$src ? $$src : $src;     # ɬ٥Υե
    my $jfrom = $ENC2JC->{lc($from)};
    $DEBUG and print STDERR "[encode: $from to utf8] $ref\n";

    if ( $from eq "utf8" ) {
        # ⤷ʤ
    } elsif ( $jfrom eq "ascii" ) {
        &latin1_to_utf8( $ref );                    # Latin1UTF8
    } elsif ( $jfrom ne "" ) {
        &euc_encode( $from, $ref, $opt );           # ǤբEUC
        &euc_decode( "utf8", $ref, $opt );          # EUCUTF8
    } else {
        my $unimap = &require_unicode_map( $from );
        my $unistr = &require_unicode_string( $from );
        $$ref = $unimap->to_unicode( $$ref );       # ǤբUCS2
        $unistr->ucs2( $$ref );                     
        $$ref = $unistr->utf8();                    # UCS2UTF8
    }
}
# -------------------------------------------------------------------- #
#   UTF8 ¾ΥɤѴ
# -------------------------------------------------------------------- #
sub decode {
    my $to = $_[0];
    my $src = \$_[1];
    my $opt = $_[2];
    my $ref = ref $$src ? $$src : $src;     # ɬ٥Υե
    my $jto = $ENC2JC->{lc($to)};
    $DEBUG and print STDERR "[decode: utf8 to $to] $ref\n";

    if ( $to eq "utf8" ) {
        # ⤷ʤ
    } elsif ( $jto eq "ascii" ) {
        &utf8_to_latin1( $ref );                    # UTF8Latin1
    } elsif ( $jto ne "" ) {
        &euc_encode( "utf8", $ref, $opt );          # UTF8EUC
        &euc_decode( $to, $ref, $opt );             # EUCǤ
    } else {
        my $unimap = &require_unicode_map( $to );
        my $unistr = &require_unicode_string( $to );
        $unistr->utf8( $$ref );
        $$ref = $unistr->ucs2();                    # UTF8UCS2
        $$ref = $unimap->from_unicode( $$ref );     # UCS2Ǥ
    }
}
# -------------------------------------------------------------------- #
#   Jcode.pm Ѥơ¾Υɤ EUC Ѵ
# -------------------------------------------------------------------- #
sub euc_encode {
    my( $from, $ref, $opt ) = @_;
    my $jfrom = $ENC2JC->{lc($from)} or die "Unknown encoding '$from'\n";
    $DEBUG and print STDERR "[euc_encode: $jfrom to euc] $ref\n";

    if( $jfrom eq "ascii" ) {
        &latin1_to_ascii( $ref );                    # Latin1ASCII(0128)
    } elsif( $jfrom ne "euc" ) {
        my $jcode = &require_jcode( $from );
        $$ref = $jcode->set( $ref, $jfrom )->euc();  # ǤբEUC
    }
}
# -------------------------------------------------------------------- #
#   Jcode.pm ѤơEUC ¾ΥɤѴ
# -------------------------------------------------------------------- #
sub euc_decode {
    my( $to, $ref, $opt ) = @_;
    my $jto = $ENC2JC->{lc($to)} or die "Unknown encoding '$to'\n";
    my $jcode = &require_jcode( $to );
    $DEBUG and print STDERR "[euc_decode: euc to $jto] $ref\n";

    if ( $jto eq "ascii" ) {
        $$ref = $jcode->set( $ref, "euc" )->utf8(); # EUCUTF8
        &utf8_to_latin1( $ref );                    # UTF8Latin1
    } elsif ( $jto eq "sjis" ) {
        $$ref = $jcode->set( $ref, "euc" )->sjis(); # EUCSJIS
    } elsif ( $jto eq "jis" ) {
        $$ref = $jcode->set( $ref, "euc" )->jis();  # EUCJIS
    } elsif ( $jto eq "utf8" ) {
        $$ref = $jcode->set( $ref, "euc" )->utf8(); # EUCUTF8
    }
}
# -------------------------------------------------------------------- #
#   Latin1(0255)ASCII(0128) ϼѴ
# -------------------------------------------------------------------- #
sub latin1_to_ascii {
    my $ref = shift;
    $$ref =~ s{
        ([\x80-\xFF])
    }{
        sprintf( "&#x%04X;", ord($1) );
    }gex;
}
# -------------------------------------------------------------------- #
#   Latin1(0255)UTF8 ϼѴ
# -------------------------------------------------------------------- #
sub latin1_to_utf8 {
    my $ref = shift;
    $$ref =~ s{
        ([\x80-\xFF])
    }{
        pack("CC"=>0xC0|(ord($1)>>6),0x80|(ord($1)&0x3F))
    }gex;
}
# -------------------------------------------------------------------- #
#   UTF8  0x01000xFFFF  &#xHHHH; ɽ˥פ
# -------------------------------------------------------------------- #
sub utf8_to_latin1 {
    my $ref = shift;
    $$ref =~ s{
        ([\xC0-\xC3])([\x80-\xBF])|
        ([\xC4-\xFF][\x80-\xBF]+)
    }{
        if ( $3 ) { 
            &one_utf8_escape($3);
        } else {
            pack( "C" => ((ord($1)&0x03)<<6)|(ord($2)&0x3F));
        }
    }gex;       # C000-
}
# -------------------------------------------------------------------- #
#   UTF8 ʸ &#xHHHH; ˥פʣʸ
# -------------------------------------------------------------------- #
sub one_utf8_escape {
    my $src = shift;
    my $array = [ unpack("C*"=>$src ) ];
    my $len = scalar @$array;
    my $ucs2 = shift @$array;
    if ( $len == 1 ) {
        $ucs2 &= 0x7F;          # 0000007F: 0xxxxxxx 
    } elsif ( $len == 2 ) {
        $ucs2 &= 0x1F;          # 008007FF: 110xxxxx 10xxxxxx 
    } elsif ( $len == 3 ) {
        $ucs2 &= 0x0F;          # 0800FFFF: 1110xxxx 10xxxxxx 10xxxxxx 
    } else {
        return $src;
    }
    foreach my $chr ( @$array ) {
        $ucs2 = ( $ucs2 << 6 ) | ( $chr & 0x3F );
    }
    sprintf( "&#x%04X;", $ucs2 );
}
# -------------------------------------------------------------------- #
#   Jcode.pm ưŪ˸ƤӽФ
# -------------------------------------------------------------------- #
sub require_jcode {
    my $code = shift;
    if ( ! defined $CACHE_JCODE ) {
        if ( ! defined $Jcode::VERSION ) {
            eval "require 'Jcode.pm';";
        }
        if ( ! defined $Jcode::VERSION ) {
            die "Jcode.pm is required for $code\n";
        }
        $CACHE_JCODE = new Jcode();
    }
    $CACHE_JCODE;
}
# -------------------------------------------------------------------- #
#   Unicode::Map ưŪ˸ƤӽФ
# -------------------------------------------------------------------- #
sub require_unicode_map {
    my $code = shift;
    if ( ! defined $CACHE_UNIMAP->{$code} ) {
        if ( ! defined $Unicode::Map::VERSION ) {
            eval "require 'Unicode/Map.pm';";
        }
        if ( ! defined $Unicode::Map::VERSION ) {
            die "Unicode::Map is required for $code\n";
        }
        $CACHE_UNIMAP->{$code} = new Unicode::Map($code) 
            or die "Unknown encoding '$code'\n";
    }
    $CACHE_UNIMAP->{$code};
}
# -------------------------------------------------------------------- #
#   Unicode::String ưŪ˸ƤӽФ
# -------------------------------------------------------------------- #
sub require_unicode_string {
    my $code = shift;
    if ( ! defined $CACHE_UNISTR ) {
        if ( ! defined $Unicode::String::VERSION ) {
            eval "require 'Unicode/String.pm';";
        }
        if ( ! defined $Unicode::String::VERSION ) {
            die "Unicode::String is required for $code\n";
        }
        $CACHE_UNISTR = new Unicode::String();
    }
    $CACHE_UNISTR;
}
# -------------------------------------------------------------------- #
#   ѡȾѥѴ饹EUCɤΤߡ
# -------------------------------------------------------------------- #
package Encode561::JP::H2Z;
sub z2h {
    my $ref = shift;
    my $jcode = &Encode561::require_jcode( "z2h" );
    $jcode->set( $ref, "euc" )->z2h();
}
sub h2z {
    my $ref = shift;
    my $jcode = &Encode561::require_jcode( "h2z" );
    $jcode->set( $ref, "euc" )->h2z();
}
# -------------------------------------------------------------------- #
;1; # End of the script.
# -------------------------------------------------------------------- #
